<script lang="ts">
  import {
    updateTaskDescription,
    type KanbanTask,
    updateTaskTitle,
    deleteKanbanTask,
    taskOptions,
    updateTaskStatus,
  } from '../../models/Kanban.js';
  import { Button, Dropdown, DropdownItem, DropdownMenu, DropdownToggle, Modal } from '@sveltestrap/sveltestrap';
  import type { TeamUser } from '@models/Team';
  import UserBadge from '@components/UserBadge.svelte';
  import TaskQuickAssign from './Task/TaskQuickAssign.svelte';
  import type { Challenge } from '@models/Challenges';
  import EditMarkdown from '@components/Markdown/EditMarkdown.svelte';
  import Markdown from '@components/Markdown/Markdown.svelte';
  import { getNotificationsContext } from 'svelte-notifications';
  import Confirm from '@components/Confirm/Confirm.svelte';
  import TaskComments from './Task/TaskComments.svelte';

  const { addNotification } = getNotificationsContext();

  export let open = false;
  export let onClose: Function = () => {};

  export function show(task_id_?: string) {
    if (task_id_) {
      task_id = task_id_;
    }
    open = true;
  }

  export function hide() {
    open = false;
    if (onClose) {
      onClose();
    }
  }
  export function toggle() {
    // call functions so callbacks are handled
    if (open) hide();
    else show();
  }

  export let teammates: TeamUser[];

  // Use the ID so the modal is stable between subscription updates
  export let task_id: string | undefined = undefined;
  export let tasks: KanbanTask[] = [];

  let task: KanbanTask | undefined = undefined;
  $: task = tasks.find((task) => task.id == task_id);

  export let assignTask: ((task_id?: string | undefined) => void) | null = null;

  $: assignee = teammates.find((member) => task && member.id === task.assignee_id);
  $: createdBy = teammates.find((member) => task && member.id === task.created_by);

  let challenge: Challenge | undefined = undefined;

  $: challenge = task?.ctf_challenge?.challenge;
</script>

<Modal isOpen={open} {toggle} size="lg">
  {#if task}
    <div class="modal-content text-white">
      <div class="modal-header text-white bg-{taskOptions.find((op) => op.status === task?.status)?.headerColor}">
        <div class="d-flex flex-row flex-wrap w-100">
          <div class="font-weight-bold fs-4 flex-grow-1">
            <EditMarkdown
              text={task.title}
              minLength={1}
              maxLength={50}
              minWidth="350px"
              lightText
              on:save={(event) => {
                if (!task_id) return;
                updateTaskTitle(task_id, event.detail);
                addNotification({
                  text: `Task Title Updated`,
                  position: 'bottom-right',
                  removeAfter: 2500,
                  type: 'success',
                });
              }}
            />
            <small>Status: {task.status}</small>
          </div>
          {#if createdBy}
            <div>
              <div class="d-inline-block align-middle text-light">Created by</div>
              <UserBadge
                userId={createdBy.id}
                firstName={createdBy.first_name}
                lastName={createdBy.last_name}
                small
                nameOnRight={false}
              />
            </div>
          {/if}
        </div>
      </div>
      <div class="modal-body">
        <div class="text-muted fs-5">Description</div>
        <EditMarkdown
          text={task.description}
          multiline
          on:save={(event) => {
            if (!task_id) return;
            updateTaskDescription(task_id, event.detail);
            addNotification({
              text: `Task Description Updated`,
              position: 'bottom-right',
              removeAfter: 2500,
              type: 'success',
            });
          }}
        />
        {#if challenge?.description}
          <hr style="border-color: white" />
          <div class="text-muted fs-5" style="flex-basis: 100%;">Challenge Description</div>
          <Markdown source={challenge?.description} />
        {/if}
      </div>
      <div class="modal-footer d-flex flex-row justify-content-between">
        <div class="text-muted fs-5" style="flex-basis: 100%;">Assignment</div>
        {#if assignee}
          <div class="d-flex flex-column">
            <UserBadge userId={assignee.id} firstName={assignee.first_name} lastName={assignee.last_name} />
          </div>
        {/if}
        <TaskQuickAssign
          class={`d-flex flex-row${assignee ? ' ms-auto' : ''}`}
          {task}
          {assignTask}
          float={assignee ? 'end' : 'left'}
        />
        <div class="text-muted fs-5" style="flex-basis: 100%;">Actions</div>
        <div class="d-flex flex-row">
          <div>
            <Dropdown class="d-inline">
              <DropdownToggle caret>{task.status}</DropdownToggle>
              <DropdownMenu>
                {#each taskOptions as op}
                  <DropdownItem
                    class="clickable"
                    on:click={() => {
                      if (!task_id || !task) return;
                      task.status = op.status;
                      updateTaskStatus(task_id, op.status);
                    }}
                  >
                    {op.status}
                  </DropdownItem>
                {/each}
              </DropdownMenu>
            </Dropdown>
          </div>
          <Confirm let:confirm={confirmDelete}>
            <Button
              on:click={() =>
                confirmDelete(() => {
                  if (!task_id) return;
                  deleteKanbanTask(task_id);
                  hide();
                  // Remove any remnants
                  task_id = undefined;
                })}
              color="danger"
              class="mx-2"
            >
              Delete
            </Button>
            <span slot="title">Delete Task</span>
            <span slot="description">
              <p>This will delete the task entirely.</p>
              <p>Are you sure you want to delete "{task.title}"?</p>
            </span>
          </Confirm>
        </div>
        <div style="flex-basis: 100%">
          <TaskComments {teammates} {task} />
        </div>
      </div>
    </div>
  {:else}
    <div class="modal-content text-white" />
  {/if}
</Modal>
